
#include "plasmoid.h"
#include <QGraphicsLinearLayout>
#include <Plasma/Label>

Plasmoid::Plasmoid(QObject *parent, const QVariantList &args)
    : Plasma::Applet(parent, args)
{
    m_rssTitle = new Plasma::Label(this);
    QGraphicsLinearLayout *layout = new QGraphicsLinearLayout(this);
    layout->addItem(m_rssTitle);
    setLayout(layout);
    dataEngine("rss")->connectSource("http://dot.kde.org/rss.xml", this);
}

Plasmoid::~Plasmoid()
{
    delete m_rssTitle;
}

void Plasmoid::dataUpdated(const QString &sourceName, const Plasma::DataEngine::Data &data)
{
    QMap<QString, QVariant> item = data["items"].toList().first().toMap();
    QString title = item["title"].toString();
    QString feedtitle = item["feed_title"].toString();
    
    QString text = "Most recent news from <b>"+feedtitle+"</b>:";
    text += "<br /><br />"+title;
    m_rssTitle->setText(text);
}

#include "plasmoid.moc"
